#include "type.h"
#include "gpu.h"

#define PAL     0
#define FRAMESKIP   0

#define	SIGN(code,basebit,bit)	(int)( (code)<<(32-basebit-bit) ) >> (32-bit)
#define do_prim(prim)           primfunc[*(UINT32*)prim>>24](prim)

enum {NOTRANS,MEM2VRAM,VRAM2MEM};

typedef struct {
    int x,y;
} POS;

typedef struct {
    int x,y,w,h;
} AREA;

typedef struct {
    UINT32  status;
    UINT32  info[8];

    POS     dispoffset;
    POS     drawoffset;
    AREA    screen;
    AREA    disp;
    POS     clip_min;
    POS     clip_max;
    AREA    texwindow;

/* primtive recieve buffer */
    UINT32  primdata[16];
    int     primsize;
    int     primptr;
    int     retval;
    int     tpage;
} GPU_Type;

typedef struct {
	BITMAPINFO bi;
	LPSTR lpBits;
	HBITMAP hbm;
} DIB;

// Global vars
extern GPU_Type  gpu;
extern UINT8     primsizeT[256];
extern void     (*primfunc[256])();
