#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#include "gpulocal.h"
#include "win32def.h"

UINT8 primsizeT[256] =
{
	0,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,	/* 00 */
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,	/* 10 */
	4,4,4,4,7,7,7,7,5,5,5,5,9,9,9,9,	/* 20 */
	6,6,6,6,9,9,9,9,8,8,8,8,12,12,12,12,/* 30 */
	3,3,3,3,0,0,0,0,5,5,5,5,6,6,6,6,	/* 40 */
	4,4,4,4,0,0,0,0,7,7,7,7,9,9,9,9,	/* 50 */
	3,3,3,3,4,4,4,4,2,2,2,2,0,0,0,0,	/* 60 */
	2,2,2,2,3,3,3,3,2,2,2,2,3,3,3,3,	/* 70 */
	4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,	/* 80 */
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,	/* 90 */
	3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,	/* a0 */
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,	/* b0 */
	3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,	/* c0 */
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,	/* d0 */
	0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,	/* e0 */
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,	/* f0 */
};

static void gpu_unknown(UINT32 *prim);
static void gpu_LoadImage(UINT16 *sp);
static void gpu_MoveImage(UINT16 *sp);
static void gpu_StoreImage(UINT16 *sp);
static void gpu_e1(UINT32 *prim);
static void gpu_e2(UINT32 *prim);
static void gpu_e3(UINT32 *prim);
static void gpu_e4(UINT32 *prim);
static void gpu_e5(UINT32 *prim);
static void gpu_e6(UINT32 *prim);

void (*primfunc[256])() = {
	/* 00 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* 10 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* 20 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* 30 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* 40 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* 50 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* 60 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* 70 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* 80 */
	gpu_MoveImage,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* 90 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* a0 */
	gpu_LoadImage,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* b0 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* c0 */
	gpu_StoreImage,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* d0 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* e0 */
	gpu_unknown,gpu_e1,gpu_e2,gpu_e3,
	gpu_e4,gpu_e5,gpu_e6,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	/* f0 */
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
	gpu_unknown,gpu_unknown,gpu_unknown,gpu_unknown,
};

static GPU_Type gpu;
static int      inTrans;
static int      initialized=0;
static HWND     hwnd;

/*
	gpu status
    0 - 10 : draw mode (e0 prim )
    11,12: mask mode
    12-15: ??
    16 - 22: disp mode
	23: Display (1=off)
    24-25: ??
	26: GPU ready (1=ready)
	27: storeimage ready (1=ready)
	28: command ready (1=ready)
	29-30: DMA mode
    31: in interlace mode, 1:odd 0:even
*/

void GPU_Update(void)
{
/* interlace odd/even */
    gpu.status^=0x80000000;
}

UINT32 GP1_Read(void)
{
	return (gpu.status | 0x1c000000) & ~0x00480000;
	// isinterheight=480 off ꂪinterlasewait̂
	/* GPU_Idle | GPU_cmd_ready | img ready */
	 //|0x800;
	/* nazo */
}

UINT32 GP0_Read(void)
{
	if (inTrans==VRAM2MEM) return 0;
	return gpu.retval;
}

void GP0_Write(UINT32 data)
{
	if (inTrans==MEM2VRAM) {
                return;
	}
	if (gpu.primptr) {
		gpu.primdata[gpu.primptr++] = data;
		if (gpu.primptr == gpu.primsize) {
			gpu.primptr = gpu.primsize = 0;
			do_prim(gpu.primdata);
		}
	} else {
		int primsize=primsizeT[data>>24];
		gpu.primdata[0] = data;
		switch(primsize) {
		case 0:
			printf("unknown prim:%08x\n",(int)data);
			break;
		case 1:
			do_prim(gpu.primdata);
			break;
		default:
			gpu.primsize = primsize;
			gpu.primptr = 1;
			break;
		}
	}
}

void GP1_Write(UINT32 code)
{
	switch(code>>24) {
	case 0x00:	/* All Reset */
		gpu.status = 0x14802000;
		/* com ready | GPU ready | display off 
		256x240, NTSC, 15bit, non-interlace,
		tpage = 0, dither off, can't draw to display area, mask off
		*/
		gpu.disp.w = gpu.screen.w = 256;
                gpu.disp.h = gpu.screen.h = 240;
		break;
	case 0x01:	/* Command Reset */
		gpu.primptr = gpu.primsize = 0;
		break;
	case 0x02:	/* IRQ Reset */
		break;
	case 0x03:	/* Display Mask */
		/* bit 1 to status bit 23 */
		gpu.status = (gpu.status & ~(1<<23)) | ((code&1)<<23);
		break;
	case 0x04:	/* DMA mode */
		/* bit 0,1 to status bit 29,30 */
		gpu.status = (gpu.status & ~(3<<29)) | ((code&3)<<29);
		break;
	case 0x05:	/* disp offset */
		gpu.dispoffset.x = code & 0x3ff;
		gpu.dispoffset.y = (code>>10) & 0x3ff;
		break;
	case 0x06: {	/* H start/end */
		int s,e;
		s = code&0xfff;
		e = (code>>12)&0xfff;
		gpu.screen.x = (s - 608)/10;
		gpu.screen.w = (e-s)/10;
		}
		break;
	case 0x07: {	/* V start/end */
		int s,e;
		s = code&0x3ff;
		e = (code>>10)&0x3ff;
		gpu.screen.y = s - PAL?19:16;
		gpu.screen.h = e-s;
		}
		break;
	case 0x08:	/* display mode */
		/* bit 0..5 to status bit 17..22  */
		/* bit    6 to status bit 16      */
		gpu.status = (gpu.status &~0x7f0000) | ((code&0x3f)<<17) | ((code&0x40)<<(16-6));
		{ static int dispw[] = {256,320,512,640};
		if (code&0x40) gpu.disp.w = 368;
		else gpu.disp.w = dispw[code&3];
		}
		gpu.disp.h = (code&4)?480:240;
		break;
	case 0x10:	/* GPU Info */
		switch(code&0xffffff) {
		case 3:
		case 4:
		case 5:
			gpu.retval = gpu.info[code&0xffffff];
			break;
		case 7:
			gpu.retval = 2; /* version */
			break;
		}
		break;
	default:
		printf("unknown %x\n",(int)code);
		break;
	}
}

static void gpu_unknown(UINT32 *prim)
{
}

static void gpu_LoadImage(UINT16 *sp)
{
	/* LoadImage */
	inTrans = MEM2VRAM;
}

static void gpu_MoveImage(UINT16 *sp)
{
}

static void gpu_StoreImage(UINT16 *sp)
{
/* StoreImage */
    inTrans = VRAM2MEM;
}

static void gpu_e1(UINT32 *prim)
{
    UINT32 code = prim[0];
/* bit 0..10 to status bit 0..10 */

    gpu.status = ( gpu.status &~0x7ff) | (code&0x7ff);
    gpu.tpage = code & 0x7ff;
}

static void gpu_e2(UINT32 *prim)
{
    UINT32 code = prim[0];

    gpu.texwindow.w = ((code&31))*8;
    gpu.texwindow.h = ((code>>5)&31)*8;
    gpu.texwindow.x = 256-((code>>10)&31)*8;
    gpu.texwindow.y = 256-((code>>15)&31)*8;
}

static void gpu_e3(UINT32 *prim)
{
    UINT32 code = prim[0];

    gpu.info[3] = code&0xffffff;
    gpu.clip_min.x = code&0x3ff;
    gpu.clip_min.y = (code>>10)&0x1ff;
}

static void gpu_e4(UINT32 *prim)
{
    UINT32 code = prim[0];

    gpu.info[4] = code&0xffffff;
    gpu.clip_max.x = code&0x3ff;
    gpu.clip_max.y = (code>>10)&0x1ff;
}

static void gpu_e5(UINT32 *prim)
{
    UINT32 code = prim[0];

    gpu.info[5] = code&0xffffff;
    gpu.drawoffset.x = ((int)code<<(32-11))>>(32-11);
    gpu.drawoffset.y = ((int)code<<(32-22))>>(32-11);
}

static void gpu_e6(UINT32 *prim)
{
    UINT32 code = prim[0];
/* bit 0,1 to status bit 11,12 */
    gpu.status = (gpu.status & ~(3<<11)) | ((code&3)<<11);
}

void GPU_DmaExec(UINT32 adr,UINT32 bcr,UINT32 chcr)
{
}


int GPU_Open(UINT32 *par)
{
    FPSEWin32 *g = (FPSEWin32 *)par;
// Setup GPU
    memset(&gpu,0,sizeof(gpu));
    gpu.info[7] = 2; /* type */
    gpu.disp.w = gpu.screen.w = 256;
    gpu.disp.h = gpu.screen.h = 240;

    hwnd = g->HWnd;
// set the flag and exit
    initialized = 1;

    return FPSE_OK;
}

void GPU_Close(void)
{
    if (!initialized) return;
}

int GPU_Configure(UINT32 *par)
{
    return FPSE_OK;
}

void GPU_About(UINT32 *par)
{
}

void CALLBACK GPU_ScreenShot(char *path)
{
}	    
