#include <windows.h>
#include <memory.h>

#include "gpulocal.h"
#include "win32def.h"

static int initialized=0;

HWND hwnd;
UINT8 *ram;

int GPU_Open(UINT32 *par)
{
    FPSEWin32 *g = (FPSEWin32 *)par;

// Setup GPU
    memset(&gpu,0,sizeof(gpu));
    gpu.info[7] = 2; /* type */
    gpu.disp.w = gpu.screen.w = 256;
    gpu.disp.h = gpu.screen.h = 240;
    DrawInit();

// Allocate screen
    vram = win_createbitmap(1024,512,16);
    if (vram == NULL) return FPSE_ERR;

// Get sysram ptr & window handle
    ram = g->SystemRam; hwnd = g->HWnd;

// Reset GPU
    GP1_Write(0);

// set the flag and exit
    initialized = 1;

    return FPSE_OK;
}

void GPU_Close(void)
{
    if (!initialized) return;
    DeleteObject(dib.hbm);
}
