#ifndef POLY2_H
#define POLY2_H

typedef struct {
    UINT8 r,g,b,code;
} COLOR;

typedef struct {
    INT32 r,g,b;
} LCOLOR;

typedef struct {
    INT32 x, u, v;
    LCOLOR c;
} EDGE;

typedef struct {
    INT16 x,y;
} POINT_F; /* flat point */

typedef struct {
    COLOR c;
    INT16 x,y;
} POINT_G; /* glow point */

typedef struct {
    INT16  x,y;
    UINT8  u,v;
    UINT16 pad;
} POINT_FT; /* flat textured point */

typedef struct {
	COLOR  c;
	INT16  x,y;
	UINT8  u,v;
        UINT16 pad;
} POINT_GT; /* grow textured point */

#include "prim2.h"

void gpu_polyF3(PolyF3 *prim);
void gpu_polyF4(PolyF4 *prim);
void gpu_polyG3(PolyG3 *prim);
void gpu_polyG4(PolyG4 *prim);
void gpu_polyFT3(PolyFT3 *prim);
void gpu_polyFT4(PolyFT4 *prim);
void gpu_polyGT3(PolyGT3 *prim);
void gpu_polyGT4(PolyGT4 *prim);

void gpu_lineF2(LineF2 *prim);
void gpu_lineF3(LineF3 *prim);
void gpu_lineF4(LineF4 *prim);
void gpu_lineG2(LineG2 *prim);
void gpu_lineG3(LineG3 *prim);
void gpu_lineG4(LineG4 *prim);

void gpu_sprt(Sprt *prim);
void gpu_sprt8(Sprt *prim);
void gpu_sprt16(Sprt *prim);

void gpu_tile(Tile *prim);
void gpu_tile1(Tile1 *prim);
void gpu_tile8(Tile8 *prim);
void gpu_tile16(Tile16 *prim);

void gpu_fill(Fill *prim);

void DrawInit(void);

void move(int x0,int y0,int x1,int y1,int w,int h);
INT16 *shade_ctbl2(INT16 *dist,INT16 *src,int size,long color);

#endif
