#ifndef __GPUGLOBALS_H__
#define __GPUGLOBALS_H__

#include <ddraw.h>
#include <d3d.h>

#ifdef GPU_DECLARE_VARS
#define EXTERN_VAR
#else
#define EXTERN_VAR	extern
#endif

// Per rimuovere i syslog
#define SYSLOG_REMOVE

// Dimensione dell Execute Buffer
#define GPUMAXEB		(4*1024)

// GPUFlags bitmask
#define GPU_DXINIT      0x01
#define GPU_TESTPASSED  0x02
#define GPU_CHANGEBPP   0x04

#ifdef  __cplusplus
extern "C" {
#endif

/* Prototipi modello 'PSExxxx()' */
char * CALLBACK PSEgetLibName(void);
unsigned long CALLBACK PSEgetLibType(void);
unsigned long CALLBACK PSEgetLibVersion(void);

/* Prototipi modello 'GPUxxxx' */
long CALLBACK GPUinit();
long CALLBACK GPUshutdown();
long CALLBACK GPUopen(HWND hwndGPU);
long CALLBACK GPUclose();
void CALLBACK GPUupdateLace(void);
unsigned long CALLBACK GPUreadStatus(void);
void CALLBACK GPUwriteStatus(unsigned long gdata);
unsigned long CALLBACK GPUreadData(void);
void CALLBACK GPUwriteData(unsigned long gdata);
void CALLBACK GPUsetMode(unsigned long gdata);
long CALLBACK GPUgetMode(void);
long CALLBACK GPUconfigure(void);
long CALLBACK GPUdmaChain(unsigned long * baseAddrL, unsigned long addr);
void CALLBACK GPUabout(void);
long CALLBACK GPUtest(void);

// GPU structure
typedef struct {
    unsigned long int  StatusRet;
    unsigned long int  DataRet;
    unsigned long int  Interlace;
    unsigned long int  DisplayOffsetX;
    unsigned long int  DisplayOffsetY;
    unsigned long int  DrawOffsetX;
    unsigned long int  DrawOffsetY;
    unsigned long int  ScreenX;
    unsigned long int  ScreenY;
    unsigned long int  ModeReg;
    unsigned long int  Flags;
    unsigned long int  ImageTransfer;
    struct {
        long int x1,y1,x2,y2;
    } Clip;
	struct {
		int x,y;
		int type;
	} Texture;
    struct {
        unsigned long int x0,y0;
        unsigned long int x1,y1;
        unsigned long int xc,yc;
        unsigned long int Len;
        unsigned long int Idx;
        unsigned long int Cmd;
        unsigned long int Buffer[256*1024];
    } Dma;
} GPU_Type;

//Exported vars
EXTERN_VAR GPU_Type            GPU;

EXTERN_VAR LPDIRECTDRAW            vga;      // DDraw object
EXTERN_VAR LPDIRECTDRAWSURFACE     vga_surf; // DDraw primary surface
EXTERN_VAR LPDIRECTDRAWSURFACE     vga_rend; // DDraw rendering surface
EXTERN_VAR RECT                    OutRect;
EXTERN_VAR LPDIRECT3D              vga3d;
EXTERN_VAR LPDIRECT3DDEVICE        vga3dDevice;
EXTERN_VAR LPDIRECT3DEXECUTEBUFFER vga3dExecute;
EXTERN_VAR LPDIRECT3DVIEWPORT      vga3dView;

static char b[64];

#undef GPU_DECLARE_VARS

#ifdef  __cplusplus
}
#endif

#endif
