#include <windows.h>
#include <memory.h>
#include <malloc.h>

#include "gpulocal.h"
#include "Win32Def.h"

static int initialized=0;

HWND   hwnd;
UINT8 *ram;

int GPU_Open(UINT32 *par)
{
    FPSEWin32 *g = (FPSEWin32 *)par;

// Setup GPU
    memset(&gpu,0,sizeof(gpu));
    gpu.info[7] = 2; /* type */
    gpu.disp.w = gpu.screen.w = 256;
    gpu.disp.h = gpu.screen.h = 240;

// Get sysram ptr & window handle
    ram = g->SystemRam; hwnd = g->HWnd;

// Allocate screen
    if (D3D_Open() != FPSE_OK) return FPSE_ERR;
    vram = (UINT16*)malloc(FRAME_W*FRAME_H*2);
    if (vram == NULL)
    {
        D3D_Close();
        return FPSE_ERR;
    }
	memset(vram,0,FRAME_W*FRAME_H*2);
// Reset GPU
    GP1_Write(0);

// set the flag and exit
    initialized = 1;

    return FPSE_OK;
}

void GPU_Close(void)
{
    if (!initialized) return;
    D3D_Close();
    free(vram);
}
