#include <windows.h>
#include <stdio.h>
#include <memory.h>

#include "gpulocal.h"

void GPU_ScreenShot(char *path)
{
 FILE   *bmpfile;
 char    filename[256];
 UINT16 *vram2;
 UINT8   header[0x36];
 UINT32  size;
 UINT8   line[1024*3];
 UINT8   empty[2]={0,0};
 UINT16  color;
 int     snapshotnr = 0,i,j;
 
 size=gpu.disp.h*gpu.disp.w*3+0x38;
 
 // fill in proper values for BMP
 
 // hardcoded BMP header
 memset(header,0,0x36);
 header[0]='B';
 header[1]='M';
 header[2]=size&0xff;
 header[3]=(size>>8)&0xff;
 header[4]=(size>>16)&0xff;
 header[5]=(size>>24)&0xff;
 header[0x0a]=0x36;
 header[0x0e]=0x28;
 header[0x12]=gpu.disp.w%256;
 header[0x13]=gpu.disp.w/256;
 header[0x16]=gpu.disp.h%256;
 header[0x17]=gpu.disp.h/256;
 header[0x1a]=0x01;
 header[0x1c]=0x18;
 header[0x26]=0x12;
 header[0x27]=0x0B;
 header[0x2A]=0x12;
 header[0x2B]=0x0B;
 
 for (;;) {
   if (++snapshotnr > 9999) return;
   sprintf(filename,"%ssnap%04d.bmp",path,snapshotnr);
   bmpfile=fopen(filename,"rb");
   if (bmpfile == NULL) break;
   fclose(bmpfile);
  }

 // try opening new snapshot file
 if((bmpfile=fopen(filename,"wb"))==NULL)
  {
   // could not open for writing !
   return;
  }
 
 fwrite(header,0x36,1,bmpfile);
 vram2=vram + (gpu.disp.h+gpu.disp.y-1)*1024 + gpu.disp.x;
 for(i=0;i<gpu.disp.h;i++)
  {
   for(j=0;j<gpu.disp.w;j++)
    {
     color=vram2[j];
     line[j*3+2]= (color >> 7) & 0xF1;
     line[j*3+1]= (color >> 2) & 0xF1;
     line[j*3+0]= (color << 3) & 0xF1;
    }
   fwrite(line,gpu.disp.w*3,1,bmpfile);
   vram2 -= 1024;
  }
 fwrite(empty,0x2,1,bmpfile);
 fclose(bmpfile);  
}	    
