#include <windows.h>
#include <io.h>
#include <memory.h>
#include <fcntl.h>

#include "type.h"

static int keybind[16] = {
	VK_INSERT,	/* L2 */
	VK_PRIOR,	/* R2 */
	VK_DELETE,	/* L1 */
	VK_NEXT,	/* R1 */
	'V',		/* /\ */
	'Z',		/*  O */
	'X',		/*  X */
	'C',		/* [] */
	VK_TAB,		/* SELECT */
	0,
	0,
	VK_RETURN,	/* START */
	VK_UP,		/* UP */
	VK_RIGHT,	/* RIGHT */
	VK_DOWN,	/* DOWN */
	VK_LEFT		/* LEFT */
};

static char *padbuf;

//--------------------------------------------------------------------

// This Function is called when emulator starts
int JOY1_Open(UINT32 *joy)
{
// Nothing to do here
 return FPSE_OK;
}

// This Function is called when emulator is closed
void JOY1_Close()
{
// Nothing to do here
}

// This function is called when the gamepad should vibrate:
// if (motor != 0) then vibrate(on) else vibrate(off)
void JOY1_Vibrate(int motor)
{
}

// Return status of buttons (see joydrv.h)
void JOY1_Poll()
{
    int i,ret=0;

    for(i=0;i<16;i++) {
        int keycode = keybind[i];
        if (keycode && GetAsyncKeyState(keycode)<0) ret|=(1<<i);
    }

    ret = ~ret;
    padbuf[3] = ret >> 8;
    padbuf[4] = ret;
}

int JOY1_InitHeader(char *buf)
{
    padbuf = buf;
    buf[1] = 0x41;
    buf[2] = 0x5A;
    return 5;
}

int JOY1_Configure(UINT32 *par)
{
    return FPSE_OK;
}

void JOY1_About(UINT32 *par)
{
}
